import java.util.Scanner;

public class Levenshtein {

    public static void main(String[] args) {
        Scanner scanner = new Scanner(System.in);
        int n = scanner.nextInt();
        int m = scanner.nextInt();
        scanner.nextLine();
        String s = scanner.nextLine();
        String t = scanner.nextLine();

        int vastus = LevenshteinDistance(n, m, s, t);
        System.out.println(vastus);
    }

    static int LevenshteinDistance(int n, int m, String s, String t)
    {
        int[][] dp = new int[n + 1][m + 1];
        for (int i = 0; i <= n; i++)
        {
            for (int j = 0; j <= m; j++)
            {
                dp[i][j] = 0;
            }
        }
        for (int i = 0; i <= n; i++)
        {
            dp[i][0] = i;
        }
        for (int i = 0; i <= m; i++)
        {
            dp[0][i] = i;
        }

        for (int i = 1; i <= n; i++)
        {
            for (int j = 1; j <= m; j++)
            {
                int sc = 1;
                if (s.charAt(i-1) == t.charAt(j-1))
                {
                    sc = 0;
                }
                dp[i][j] = Math.min(Math.min(dp[i - 1][j] + 1, dp[i][j - 1] + 1), dp[i - 1][j - 1] + sc);
            }
        }

        return dp[n][m];
    }
}
